\\ ---------- Methods for the computation of periods ----------

CY_Indicials(L,p)={
    L=polcoef(CY_Pointchange(L,p),0,z);
    local(indicials=factor(L));
    Set(vector(matsize(indicials)[1],X,[-polcoef(indicials[X,1],0,Theta)/polcoef(indicials[X,1],1,Theta),indicials[X,2]]))
};

CY_Pointchange(L,p)={
    local(tmp=1,Lnew=0);
    if(
        p!=oo,for(k=0,4,Lnew+=subst(polcoef(L,k,Theta),z,z+p)*tmp;tmp=(z+p)/z*(z*deriv(tmp,z)+tmp*Theta)),
        p==oo,Lnew=subst(subst(L,Theta,-Theta),z,1/z)
    );
    Lnew/z^(-poldegree(subst(lift(Lnew),z,1/z),z))
};

CY_Solve(L,p,ord,numval)={
    local(ind=CY_Indicials(L,p),indset=Set(apply(x->x[1],ind)));
    L=CY_Pointchange(L,p);
    local(f=vector(#ind,X,vector(ind[X][2],Y,0)));
    local(disc,num,c=0);
    for(X=1,#f,
        f[X][1]=z^ind[X][1]*(1+numval-numval);
        for(k=ind[X][1]+1,ord,
            for(Y=1,ind[X][2],
                disc=subst(polcoef(L,0,z),Theta,k);
                if(setsearch(indset,k)&&Y<ind[X][2],disc=subst(deriv(polcoef(L,0,z),Theta),Theta,k);c=1);
                if(setsearch(indset,k)==0||c==1,
                    num=sum(i=0,min(poldegree(L,z),k),sum(j=1,Y,subst(diffop(polcoef(L,i,z),[Theta],[1],j-1+c),Theta,k-i)/(j-1)!*polcoef(f[X][Y+1-j],k-i,z)));
                    f[X][Y]+=-num/disc*z^k
                );
                c=0;
            )
        )
    );
    f=apply(x->vector(#x,Y,sum(k=0,Y-1,x[Y-k]/k!*Log^k)),f);
    for(i=2,#f,f[1]=concat(f[1],f[i]));
    [f[1],p]
};

CY_Transmat(sol1,sol2,p)={
    local(A=matid(4),B=matid(4),p1,p2);
    A[,1]=sol1[1]~;
    B[,1]=sol2[1]~;
    for(i=2,4,
        A[,i]=(-z^2)^(sol1[2]==oo)*(deriv(A[,i-1],z)+deriv(A[,i-1],Log)/z);
        B[,i]=(-z^2)^(sol2[2]==oo)*(deriv(B[,i-1],z)+deriv(B[,i-1],Log)/z);
    );
    if(
        sol1[2]==oo,p1=1/p,
        True,p1=p-sol1[2]
    );
    if(
        sol2[2]==oo,p2=1/p,
        True,p2=p-sol2[2]
    );
    A=subst(subst(A,z,p1),Log,log(p1));
    B=subst(subst(B,z,p2),Log,log(p2));
    A*matsolve(B,matid(4))
};



\\ ---------- Computations ----------

default(parisize,"1G")
default(realprecision,"100")
default(format,"g.15")

ord = 200;

L = Theta^4-2^8*z*(Theta+1/2)^4;
zStar = (17-12*sqrt(2))/2^8;
f0 = CY_Solve(L,0,ord,1.0)[1];
f0 *= [(2*Pi*I)^3,0,0,0;0,(2*Pi*I)^2,0,0;0,0,2*Pi*I,0;-8*zeta(3),0,0,1]~;
T = matrix(4,4);
T[,1] = f0~;
for(i=1,3,T[,i+1] = z*deriv(T[,i],z)+deriv(T[,i],Log));
T = substvec(T,[z,Log],[zStar,log(zStar)]);
A = [0,-6,0,-6;6,0,6,0;0,2+3*sqrt(2),0,2-3*sqrt(2);2-3*sqrt(2),0,2+3*sqrt(2),0];
B = [32,-8+2*sqrt(2),2-sqrt(2),0;0,0,0,1;0,32,0,-10+7*sqrt(2);0,0,-16,12-7*sqrt(2)];
print("Checking splitting of period matrix:");
printp(A^(-1)*T*B^(-1));
