\\ ---------- Computations ----------

MUMSOL(L,ord) = {
  local(f=vector(poldegree(L,Theta)));
  f[1]=1; 
  L=matrix(#f,poldegree(L,z)+1,X,Y,diffop(polcoef(L,Y-1,z),[Theta],[1],X-1));
  for(X=1,#f,
      for(k=1,ord,
	    f[X]-=sum(i=0,min(#L-1,k),sum(j=1,X,subst(L[j,i+1],Theta,k-i)/(j-1)!*polcoef(f[X-j+1],k-i,z)))/subst(L[1,1],Theta,k)*z^k
	  );
      f[X]+=O(z^(ord+1))
      );
  f
};

modularity(L,k,l,beta,ord) = {
  local(f,tSer,extension,tNewSer,f4);
  f = MUMSOL(L,ord);
  tSer = -polcoef(polcoef(L,3,Theta),1,z)*serreverse(subst(z*exp(f[2]/f[1]),z,q));
  extension = s^(k+l)-((-1)^k*k^k*l^l/(k+l)^(k+l)/polcoef(tSer,1,q));
  tNewSer = Mod(s/q+O(q^0),extension);
  for(i=0,ord,
      tNewSer = Mod(truncate(tNewSer)+tmp*q^i+O(q^(i+1)),extension);
      tNewSer = subst(tNewSer,tmp,(toVanish->Mod(-subst(toVanish,tmp,0)/polcoef(toVanish,1,tmp),extension))(lift(polcoef((-1)^k*k^k*l^l/(k+l)^(k+l)/tNewSer^k/(1+tNewSer)^l - subst(tSer,q,q^(k+l)),k+l+i+1,q))));
      );
  print("Checking parametrization: ",(-1)^k*k^k*l^l/(k+l)^(k+l)/tNewSer^k/(1+tNewSer)^l - subst(tSer,q,q^(k+l)));
  if(beta==1/2,
     tNewSer = subst(tNewSer,q,q^2);
     tSer = subst(tSer,q,q^2);
     f4 = 1/tNewSer/((1+tNewSer)/polcoef(tNewSer,-2,q))^beta*subst(f[1],z,subst(tSer,q,q^(k+l))/(-polcoef(polcoef(L,3,Theta),1,z)))*q*deriv(tNewSer,q),
     f4 = 1/tNewSer/(1+tNewSer)^beta*subst(f[1],z,subst(tSer,q,q^(k+l))/(-polcoef(polcoef(L,3,Theta),1,z)))*q*deriv(tNewSer,q);
     );	
  [extension,polcoef(f4,1,q),lift(f4 / polcoef(f4,1,q))]
};

ord = 100;

L = Theta^3-2^6*z*(Theta+1/2)*(Theta+1/2)*(Theta+1/2);
f = mfeigensearch([8,4])[1];
f = mflinear([mftwist(f,-4)],[1]);
print(Mod(modularity(L,1,1,1,ord),s-I/2^4)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([8,4])[1];
f = mflinear([mftwist(f,-8)],[1]);
print(Mod(modularity(L,2,2,1,ord),s^2-1/2^5)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([8,4])[1];
f = mflinear([mftwist(f,8),mftwist(f,-8)],[1/(1+I),1/(1-I)]);
print(Mod(modularity(L,1,1,1/2,ord),s-I/2^4)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");

L = Theta^3-2^2*3^3*z*(Theta+1/3)*(Theta+1/2)*(Theta+2/3);
f = mfeigensearch([12,4])[1];
f = mflinear([f],[1]);
print(Mod(modularity(L,1,1,1,ord),s^2+1/(2^4*3^3))-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([27,4])[1];
f = mflinear([f],[1]);
print(Mod(modularity(L,2,1,1,ord),s-1/3^2)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([8,4])[1];
f = mflinear([f,mftwist(f,-4),mfbd(f,2),mfbd(f,3),mfbd(mftwist(f,-4),3),mfbd(f,6)],[1/2-1/2*I,1/2+1/2*I,-2+2*I,9/2-9/2*I,-9/2-9/2*I,-18+18*I]);
print(Mod(modularity(L,3,1,1,ord),s-(1/8+I/8))-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigenbasis(mfinit([48,4,12],0))[1];
print(Mod(modularity(L,2,2,1,ord),s^4-1/1728)-[0,0,Ser(subst(lift(mfcoefs(f,ord)),y,36*s^2+1/2),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([25,4])[2];
f = mflinear([f,mfbd(f,3)],[1,-9]);
print(Mod(modularity(L,3,2,1,ord),s+1/5)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigenbasis(mfinit([48,4,12],0))[1];
print(Mod(modularity(L,1,1,1/2,ord),s^2+1/432)-[0,0,Ser(subst(lift(mfcoefs(f,ord)),y,18*s+1/2),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([108,4])[1];
f = mflinear([f],[1]);
print(Mod(modularity(L,2,1,1/2,ord),s-1/3^2)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");

L = Theta^3-2^8*z*(Theta+1/4)*(Theta+1/2)*(Theta+3/4);
f = mfeigensearch([8,4])[1];
f = mflinear([f],[1]);
print(Mod(modularity(L,1,1,1,ord),s-I/2^5)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([9,4])[1];
f = mflinear([f,mfbd(f,2)],[1,-4]);
print(Mod(modularity(L,2,1,1,ord),s-1/(2^2*3))-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([32,4])[1];
f = mflinear([f],[1]);
print(Mod(modularity(L,2,2,1,ord),s-1/2^3)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([25,4])[2];
f = mflinear([f,mfbd(f,2)],[1,-4]);
print(Mod(modularity(L,4,1,1,ord),s-1/5)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([128,4])[2];
f = mflinear([f],[1]);
print(Mod(modularity(L,4,4,1,ord),s-1/2^2)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([32,4])[1];
f = mflinear([f,mftwist(f,-4)],[1/(1-I),1/(1+I)]);
print(Mod(modularity(L,1,1,1/2,ord),s-I/2^5)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([24,4])[1];
f = mflinear([f,mfbd(f,3)],[1,-9]);
print(Mod(modularity(L,1,2,1/2,ord),s+1/(2^2*3))-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([72,4])[1];
f = mflinear([f],[1]);
print(Mod(modularity(L,2,1,1/2,ord),s-1/(2^2*3))-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([128,4])[2];
f = mflinear([mftwist(f,8)],[1]);
print(Mod(modularity(L,2,2,1/2,ord),s-1/2^3)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
f = mfeigensearch([200,4])[6];
f = mflinear([mftwist(f,5)],[1]);
print(Mod(modularity(L,4,1,1/2,ord),s-1/5)-[0,0,Ser(mfcoefs(f,ord),q)]," with level ",mfparams(f)[1],"\n");
